import 'dart:isolate';

class Isolated {
  ReceivePort port = ReceivePort();

  run(Function() func) async {
    port = ReceivePort();
    final isolate = await Isolate.spawn<List<dynamic>>(
      (d) async {
        SendPort port = d[0];
        final data = await func();
        port.send(data);
      },
      [port.sendPort],
    );
    final data = port.first;
    print(data);
    isolate.kill(priority: Isolate.immediate);
    return data;
  }

  parse(datas) async {
    port = ReceivePort();
    final isolate = await Isolate.spawn<List<dynamic>>(
      (d) async {
        SendPort port = d[0];
        Map data = d[1];
        int _counter = 0;
        String body = '?';
        data.forEach((key, value) {
          ++_counter;
          if (value != '' && value != null) {
            if (!(_counter == data.length)) {
              body += '$key=$value&';
            } else {
              body += '$key=$value';
            }
          }
        });
        port.send(body);
      },
      [port.sendPort, datas],
    );
    final data = port.first;
    isolate.kill(priority: Isolate.immediate);
    return data;
  }
}
